//here should be the new versions of functions we get called with our hooks

#include "plugin.h"

#ifndef REGISTERING_CLIENT_COMMANDS
#include <extdll.h>		//always
#include <string.h> //to prevent linux errors while processing meta_api.h
#include <meta_api.h>
#include <cbase.h>
#include <player.h>
//all those goddamn includes, just so we can access CBaseEntity
#endif

#define CLIENT_COMMAND_DEFINITIONS
#include "complexmacros.h"
#undef CLIENT_COMMAND_DEFINITIONS

#include <sdk_util.h> //useful almost everywhere


float fuelfactor = 10.0;
float hagenerator = 1.0;

//send the super duper greeting of doom
BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{	
	CLIENT_PRINTF( pEntity, print_console, "\nJetpackHeavy Plugin version ");
	CLIENT_PRINTF( pEntity, print_console, MY_VERSION);
	CLIENT_PRINTF( pEntity, print_console, "                ");
	CLIENT_PRINTF( pEntity, print_console, MY_DATE);
	CLIENT_PRINTF( pEntity, print_console, "\n");
	CLIENT_PRINTF( pEntity, print_console,"By: Xeph de la christallire / [SPS] Julia Saint [xeph@korea.com] (Studio mono)\n");

	RETURN_META_VALUE(MRES_IGNORED, true);
}

int Spawn(edict_t *pEntity) {
	if(FStrEq(STRING(pEntity->v.classname), "worldspawn")) //worldspawn means that everything is just starting up
	{
		//this is the only place you can precache new things, so do it here
		DynamicSizedData.Initialize();
		fuelfactor		= CVAR_GET_FLOAT("mp_jh_fuelfactor");
		hagenerator		= CVAR_GET_FLOAT("mp_jh_generator");

		RETURN_META_VALUE(MRES_HANDLED, 0);
	}

	RETURN_META_VALUE(MRES_IGNORED, 0);
}


//you don't need to really understand this, basically it just uses my macros to 
//reroute client commands to the functions you declare in clientcommands.h
void ClientCommand( edict_t *pEntity )
{
	const char* szUserCommand = CMD_ARGV(0);
	if( szUserCommand[0] == '\0' ) return; //to get rid of warnings if the plugin doesn't make any client commands

	//these next 3 lines will use the super duper DEFINE_CLIENT_COMMAND() macro to route each command to the appropriate function
	#define REGISTERING_CLIENT_COMMANDS
		#include "complexmacros.h"
	#undef REGISTERING_CLIENT_COMMANDS
	
	RETURN_META(MRES_IGNORED);
}

void DispatchTouch(edict_t *pentTouched, edict_t *pentOther) 
{
	if(FStrEq(STRING(pentTouched->v.classname), "item_jetpack")) 
	{		
		CBaseEntity *pentFind = NULL;
		while((pentFind = UTIL_FindEntityInSphere( pentFind, pentTouched->v.origin, 40.0f)) != NULL) 
		{
			if (pentOther->v.team != 1) //he's not a marine? 
				continue;

			CBasePlayer *pPlayer = (CBasePlayer *)GET_PRIVATE(pentOther);
			if (pPlayer == NULL) continue;

			if (FStrEq(STRING(pentOther->v.classname), "player"))
			{
				//CLIENT_PRINTF(pentOther, print_console, "You've got Jetty!\n");
				if (pPlayer->pev->iuser4&512) //this player had a jetty
					continue;
				else
				{
					pPlayer->pev->iuser4 |= 512; //give a jetty!

					EMIT_SOUND_DYN2(pPlayer->edict(), CHAN_STATIC, "items/pickup_jetpack.wav", 1.0f, ATTN_NORM, 0, 100);
					REMOVE_ENTITY(pentTouched);
					break;
				}
			}
		}
	}
	
	if(FStrEq(STRING(pentTouched->v.classname), "item_heavyarmor")) 
	{		
		CBaseEntity *pentFind = NULL;
		while((pentFind = UTIL_FindEntityInSphere( pentFind, pentTouched->v.origin, 40.0f)) != NULL) 
		{
			if (pentOther->v.team != 1) continue;
			
			CBasePlayer *pPlayer = (CBasePlayer *)GET_PRIVATE(pentOther);
			if (pPlayer == NULL) continue;

			if (FStrEq(STRING(pentOther->v.classname), "player"))
			{
				//CLIENT_PRINTF(pentOther, print_console, "You've got Heavy!\n");
				if (pPlayer->pev->iuser4&32768) //this player had a heavy
					continue;
				else
				{
					pPlayer->pev->iuser4 |= 32768; //give a heavy!

					//based on my memory :d
					pPlayer->pev->armorvalue = 200;
					if (pPlayer->pev->iuser4&64) pPlayer->pev->armorvalue += 30;
					if (pPlayer->pev->iuser4&128) pPlayer->pev->armorvalue += 30;
					if (pPlayer->pev->iuser4&256) pPlayer->pev->armorvalue += 30;

					EMIT_SOUND_DYN2(pPlayer->edict(), CHAN_STATIC, "items/pickup_heavy.wav", 1.0f, ATTN_NORM, 0, 100);
					REMOVE_ENTITY(pentTouched);
					break;
				}
			}
		}
	}

	RETURN_META(MRES_HANDLED);
}

void StartFrame()
{
	//frame-based jetpack fuel deal. is this good?
	//factor 10.0 flighttime : JP 7.0(not exactly) => JH 3.0~3.5(not exactly)
	for(int playercounter = 1; playercounter <= gpGlobals->maxClients; ++playercounter)
	{
		CBasePlayer *pPlayer = (CBasePlayer*)UTIL_PlayerByIndex( playercounter );

		if (pPlayer == NULL) continue;
		if (pPlayer->pev->team != 1) continue;

		//he's got JH and in flight (omg)
		if ( (pPlayer->pev->iuser4&32768) && (pPlayer->pev->iuser4&512) && (pPlayer->pev->button&IN_JUMP))
		{
			pPlayer->pev->fuser3 = max((float)(pPlayer->pev->fuser3-fuelfactor), 0);
		}
		else if ( (pPlayer->pev->iuser4&32768) && (pPlayer->pev->iuser4&512) && (hagenerator >= 0.1) )
		{
			pPlayer->pev->fuser3 = min((float)(pPlayer->pev->fuser3 + (fuelfactor*hagenerator) ), 1000);			
		}
	}
	
	RETURN_META(MRES_HANDLED);
}